// PCM: ANIMATED MESH DEFORMATIONS
// *******************************
// This animation shows how the deform_mesh macro can be used to
// apply animated deformations to a compressed mesh file.
//
// Suggested frames: 50 - 75, non-cyclic.

// CAMERA AND LIGHT
   camera {location -z*3}
   light_source {<20, 10, -60> rgb 1.2}

// MESH DEFORMATIONS
   #include "pcm.mcr"

   #switch (clock)
   #range (0, .3)
      #declare mclock = clock / .3;
      #declare WaveCurve = (sin((mclock - .25)*2*pi) + 1) / 2;
      #macro deform_mesh () wave_mesh (WaveCurve*.3, 6, mclock) #end
      #break

   #range (.3, .4)
      #macro deform_mesh () jitter_mesh (.3, int(clock*1e6)) #end
      #break
   
   #range (.4, .9)
      #declare mclock = (clock - .4) / .5;
      #declare WaveCurve = (sin((mclock - .25)*2*pi) + 1) / 2;
      #macro deform_mesh () ripple_mesh (x, WaveCurve*.25, 10, mclock) #end
   #end

// CREATE MESH AND APPLY DEFORMATIONS
   object {read_mesh ("sphere.pcm")
      pigment {gradient y color_map {
         [.1 rgb <1, .5, .5>] [.4 rgb <1, 1, .5>] [.5 rgb <.5, 1, .5>]
         [.7 rgb <.5, .7, 1>] [.9 rgb <1, .5, 1>] [1 rgb <1, .5, .5>]}
         scale 2 translate -y}
      finish {phong .3 phong_size 65}}
