// PCMHAIR: HAIR ANIMATION EXAMPLE
// *******************************
// This animation shows how the various hair options can be animated to
// move the hair in different ways.
//
// NB: This animation also requires the Automatic Clock Modifier macro file.
//
// Suggested frames: 70 - 100, non-cyclic.
// Aspect ratio is 1:1 (eg. 160x160, 300x300, etc).

// CAMERA AND LIGHTS
   camera {right x up y location <0, 1, -5> look_at <0, 0, 0> angle 40}
   light_source {<-10, 20, -100> rgb 1 shadowless}
   light_source {<0, 60, 0> rgb .5}

// BACKGROUND AND FLOOR
   background {rgb 1}
   disc {-y, y, 5 pigment {rgb 1} finish {ambient .5 diffuse 1}}
   default {finish {ambient .2 diffuse .8}}

// HAIR OPTIONS
   #include "pcmhair.mcr"
   #include "autoclck.mcr"
   #declare apply_hair_materials_to_mesh = true;
   #declare hair_pattern_pigment = pigment {leopard color_map {
      [0 rgb <.9, .8, .3>] [.3 rgb <.8, .6, .1>] [.7 rgb 0] [1 rgb <.9, .7, .2>]}
      warp {turbulence .3 octaves 3} scale .1}
   #declare hair_rotate_to_surface = true;
   #declare hair_thickness = .02;
   #declare hairs_per_patch = 30;
   #declare hair_objects_per_unit = 10;

// ANIMATE HAIR GROWING AND RETRACTING
   #declare hair_length = 0; Declare_From (hair_length, 0)
   Declare_To_Using (hair_length, .2, 1, "S")
   Declare_To (hair_length, .9, 1)
   Declare_To_Using (hair_length, 1, 0, "A")

// ANIMATE HAIR CURLING AND STRAIGHTENING
   #declare hair_radius = 1; Declare_From (hair_radius, .2)
   Declare_To_Using (hair_radius, .375, 10, "W")
   Declare_To_Using (hair_radius, .55, .2, "W")

// ANIMATE HAIR DIRECTION CHANGING
   #declare hair_rotation = x*50; Declare_From (hair_rotation, .55)
   Declare_To_Using (hair_rotation, .725, <-10, -90, 0>, "W")
   Declare_To_Using (hair_rotation, .9, <110, 90, 0>, "W")

// CREATE HAIR ON MESH
   read_mesh ("sphere.pcm")
