// PCM: CREATE_MESH EXAMPLES
// *************************
// This scene shows how the create_mesh macro can be defined to use
// the compressed mesh data to create other objects.

// CAMERA AND LIGHTS
   camera {location -z * 8}
   light_source {<-100, 100, -800> rgb 1.2}
   light_source {<200, -50, -100> rgb <.3, .4, .5> shadowless}

// BACKGROUND PLANE
   plane {z, 5 pigment {checker rgb .3, rgb .7 scale 2}}

   #include "pcm.mcr"

// UNMODIFIED MESH
   object {read_mesh ("sphere.pcm")
      pigment {rgb 1}
      finish {phong .3 phong_size 15}}

// POINT CLOUD MESH
   #macro create_mesh () object_mesh (
      box {-.5, .5 rotate <45, 45, 0> scale <.1, .15, .1>}
      ) #end
   object {read_mesh ("sphere.pcm")
      pigment {gradient y color_map {
         [0 rgb <1, 0, 0>] [1 rgb <1, 1, 0>]}
         scale 2.2 translate -y}
      translate y*2.5}

// BLOB MESH
   #macro create_mesh () blob_mesh (1, .4, false) #end
   object {read_mesh ("sphere.pcm")
      pigment {wrinkles color_map {
         [0 rgb <1, .6, .8>] [1 rgb <.9, .7, 1>]}
         scale 3}
      finish {phong .05 phong_size 5}
      translate vrotate (y*2.5, -z*72)}

// WIREFRAME MESH
   #macro create_mesh () wire_mesh (.01) #end
      object {read_mesh ("sphere.pcm")
      pigment {rgb <0, .7, .2>}
      translate vrotate (y*2.5, -z*144)}

// SPIKE MESH
   #macro create_mesh () spike_mesh (2, 1) #end
      object {read_mesh ("sphere.pcm")
         pigment {rgb .6}
         finish {specular .7 roughness .007 metallic}
      translate vrotate (y*2.5, -z*216)}

// CYLINDER MESH
   #macro create_mesh () cylinder_mesh (.02, false, true, false) #end
      object {read_mesh ("sphere.pcm")
         pigment {rgb <.5, .7, 1>}
      translate vrotate (y*2.5, -z*288)}
